start clufctxh(outtree,tcod,tid,h,n,gkat,titre);
call execute('use ',outtree,' var {idobs cluster clusname};');
read all; close; nr=18;
m=int(sqrt(2*n)+1); if n=50 then m=10; r=mod(n,m); q=(n-r)/m;
if r=0  then rg=2*q-1; else rg=2*q+1;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/m-int(100/m)>=.5 then ph=int(100/m)+.5; else ph=int(100/m);
p=nrow(rep); xbox={0 0 1 1}; ybox={0 1 1 0}; b={0 0 1 1}; a=j(1,4,0);
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=ncol(unique(clusname)); ncoul=nrow(colors); ttcol='black';
if nclus> ncoul then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
call gstart(gkat,1); call gopen("CLUFCTXT",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do j=1 to rg by 2;
 if j^=rg | (j=rg & r=0) then
   do i=1 to m;
    a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a); k=i+int(j/2)*m;
    xx=loc(idobs=concat("No",char(k,taille(n))));
    jj=cluster[xx];coul=colors[jj];
    x=loc(tcod=k); ntx=ncol(x);
    if ntx>0 then text=tid[x];
             else call gpoly(xbox,ybox,,'black','solid',coul);
    if ntx>0 & ntx<=9 then
        do; text=substr(text,1,18);
            x1=j(1,ntx,.1); y1=do(.9,(9-ntx+1)*.1,-.1);
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1,y1,text,,,h,'swissb',ttcol); end;
    if ntx>9 & ntx<=18 then
        do; nr=ntx-9; text=substr(text,1,8);
            x1=j(1,9,.1); x2=j(1,nr,.6);
            y1=do(.9,.1,-.1); y2=do(.9,(9-nr+1)*.1,-.1);
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1||x2,y1||y2,text,,,h,'swissb',ttcol); end;
    if ntx>18 then
        do; text=substr(text[1:17,],1,8)//concat("n=",char(ntx,8));
            x1=j(1,9,.1); x2=j(1,9,.6);
            y1=do(.9,.1,-.1); y2=y1;
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1||x2,y1||y2,text,,,h,'swissb',ttcol); end;
   end;
 if j=rg & r^=0  then
   do i=1 to r;
    a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a); k=i+int(j/2)*m;
    xx=loc(idobs=concat("No",char(k,taille(n))));
    jj=cluster[xx];coul=colors[jj];
    x=loc(tcod=k); ntx=ncol(x);
    if ntx>0 then text=tid[x];
             else call gpoly(xbox,ybox,,'black','solid',coul);
    if ntx>0 & ntx<=9 then
        do; text=substr(text,1,18);
            x1=j(1,ntx,.1); y1=do(.9,(9-ntx+1)*.1,-.1);
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1,y1,text,,,h,'swissb',ttcol); end;
    if ntx>9 & ntx<=18 then
        do; nr=ntx-9; text=substr(text,1,8);
            x1=j(1,9,.1); x2=j(1,nr,.6);
            y1=do(.9,.1,-.1); y2=do(.9,(9-nr+1)*.1,-.1);
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1||x2,y1||y2,text,,,h,'swissb',ttcol); end;
    if ntx>18 then
        do; text=substr(text[1:17,],1,8)//concat("n=",char(ntx,8));
            x1=j(1,9,.1); x2=j(1,9,.6);
            y1=do(.9,.1,-.1); y2=y1;
            call gpoly(xbox,ybox,,'black','solid',coul);
            call gscript(x1||x2,y1||y2,text,,,h,'swissb',ttcol); end;
   end;
end;
call gclose; call gshow("CLUFCTXT"); call gstop;
finish clufctxh;
store module=clufctxh;
