start clusdima(outtree,e,w,code,m,n,gkat,titre);
call execute('use ',outtree,' var {idobs cluster clusname};');
read all; close;
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=ncol(unique(clusname));
ncoul=nrow(colors);
if nclus> ncoul then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/n-int(100/n)>=.5 then ph=int(100/n)+.5; else ph=int(100/n);
nu=m*n; d=j(nu,9,0);
IN=mintra(e,w,code); INV=ginv(IN);
do k=1 to nu; v=grivois(k,m,n,1); do j=1 to nrow(v)*ncol(v);
d[k,j]=sqrt((w[,k]-w[,v[j]])`*INV*(w[,k]-w[,v[j]])); end; end; d=d/d[<>];
xbox={0 0 1 1}; ybox={0 1 1 0};
b={0 0 1 1}; a=j(1,4,0);
call gstart(gkat,1); call gopen("clusdima",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do i=1 to m;
  do j= 1 to n;
    x={0 .5 1 1  1 .5 0 0  0}; y={1 1 1 .5 0  0 0 .5 1};
    a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a);
    k=(j-1)*m+i; z=loc(idobs=concat("No",char(k,taille(m*n))));
    jj=cluster[z]; coul=colors[jj];
if i=1 then do; if j=1 then
     do; x={.5 .5 .5 1  1 .5 .5 .5 .5}; y={.5 .5 .5 .5 0  0 .5 .5 .5};
     x[4]=1-d[k,2]/2; x[5]=1-d[k,4]/2; y[5]=d[k,4]/2; y[6]=d[k,3]/2; end;
   if j=n then
   do; x={.5 .5 .5 .5  .5 .5 0 0 .5}; y={.5 .5 .5 .5 .5  0 0 .5 .5};
   x[7]=d[k,3]/2; x[8]=d[k,1]/2; y[6]=d[k,4]/2; y[7]=x[7]; end;
if j^=1 & j^=n then
   do; x={.5 .5 .5 1  1 .5 0 0  .5}; y={.5 .5 .5 .5 0  0 0 .5 .5};
   x[4]=1-d[k,3]/2; x[5]=1-d[k,6]/2; x[7]=d[k,4]/2; x[8]=d[k,1]/2;
   y[5]=d[k,6]/2; y[6]=d[k,5]/2; y[7]=x[7]; end;            end;
if i=m then do; if j=1 then
  do; x={.5 .5 1 1 .5 .5 .5 .5 .5}; y={.5 1 1 .5 .5 .5 .5 .5 .5};
  x[3]=1-d[k,2]/2; x[4]=1-d[k,4]/2; y[2]=1-d[k,1]/2; y[3]=x[3]; end;
  if j=n then
      do; x={0 .5 .5 .5  .5 .5 .5 0  0}; y={1 1 .5 .5 .5 .5 .5 .5 1};
      x[1]=d[k,1]/2; x[8]=d[k,3]/2; x[9]=x[1];
      y[1]=1-d[k,1]/2; y[2]=1-d[k,2]/2; y[9]=y[1]; end;
  if j^=1 & j^=n then
   do; x={0 .5 1 1 .5 .5 .5 0  0}; y={1 1 1 .5 .5 .5 .5 .5 1};
   x[1]=d[k,1]/2; x[3]=1-d[k,3]/2; x[4]=1-d[k,6]/2; x[8]=d[k,4]/2; x[9]=x[1];
   y[1]=1-d[k,1]/2; y[2]=1-d[k,2]/2; y[3]=x[3]; y[9]=y[1]; end;        end;
if i^=1 & i^=m then do; if j=1 then
  do; x={.5 .5 1 1  1 .5 .5 .5 .5}; y={.5 1 1 .5 0  0 .5 .5 .5};
      x[3]=1-d[k,2]/2; x[4]=1-d[k,4]/2; x[5]=1-d[k,6]/2; y[3]=x[3];
      y[2]=1-d[k,1]/2; y[5]=d[k,6]/2; y[6]=d[k,5]/2; end;
if j=n then
     do; x={0 .5 .5 .5 .5 .5 0 0  0}; y={1 1 .5 .5 .5 0 0 .5 1};
      x[1]=d[k,1]/2; x[7]=d[k,5]/2; x[8]=d[k,3]/2; x[9]=x[1];
      y[1]=1-d[k,1]/2; y[2]=1-d[k,2]/2; y[6]=d[k,6]/2;
      y[7]=x[7]; y[9]=y[1]; end;
if j^=1 & j^=n then
    do; x[1]=d[k,1]/2; x[3]=1-d[k,3]/2; x[4]=1-d[k,6]/2;
    x[5]=1-d[k,9]/2; x[7]=d[k,7]/2; x[8]=d[k,4]/2; x[9]=x[1];
    y[1]=1-d[k,1]/2; y[2]=1-d[k,2]/2; y[3]=x[3];
    y[5]=d[k,9]/2; y[6]=d[k,8]/2; y[7]=x[7]; y[9]=y[1]; end;          end;
    call gpoly(xbox,ybox,,'black');
    call gpoly(x,y,,coul,'solid',coul);
  end;
end;
call gclose; call gshow("clusdima"); call gstop;
finish clusdima;
store module=clusdima;
