start kdafcnf(pot,ws,us,e,w0,u0,n,tmax);
p=nrow(e); q=ncol(e); nu=n;
if nrow(w0)^=p | ncol(w0)^=nu then return;
if nrow(u0)^=q | ncol(u0)^=nu then return;
eps0=.3; c0=.2;
pot=j(tmax,2,0);
ws=j(p,nu,0); us=j(q,nu,0);
w=w0; u=u0;
ec=pkor(e); el=pkor(e`);
do t=1 to tmax;
  r=rayon(nu,n,tmax,t);
  pot[t,1]=nrj1f(w,ec,n,r);
  pot[t,2]=nrj1f(u,el,n,r);
  jj=floor(q*uniform(1)+1);   /* on tire un individu dans EC */
  x=ec[,jj];
  zx=el[,ec[,jj][<:>]];       /* sa modalite associee (la + rare) */
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];     /* le gagnant de l'individu */
  epst=eps0/(1+c0*t/nu);                    /* sur wp (=w) */
  if r>.5  then v=voisfic(k,n,r);
  if r=.5  then v=voisfic(k,n,1);
  if r=0   then v=k;
  ws=w; us=u;
  do j=1 to nrow(v)*ncol(v);   /* mise a jour pour le gagnant & voisins */
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);   /* sur wp & wq */
    us[,v[j]]=u[,v[j]]+epst*(zx-u[,v[j]]);
  end;
  w=ws; u=us;
  ii=floor(p*uniform(1)+1);  /* on tire une modalite dans EL */
  z=el[,ii];
  o=sqrt((u-repeat(z,1,nu))[##,])[>:<];  /* son gagnant dans wq */
  if r>.5  then s=voisfic(o,n,r);
  if r=.5  then s=voisfic(o,n,1);
  if r=0   then s=o;
  ws=w; us=u;
  do j=1 to nrow(s)*ncol(s);  /* mise a jour pour le gagnant & voisins */
    us[,s[j]]=u[,s[j]]+epst*(z-u[,s[j]]);  /* pour wq SEULEMENT */
  end;
 w=ws; u=us;
end;
finish kdafcnf;
store module=kdafcnf;
