start kogacm2(lib,B,modal,D,indiv);
label=modal//indiv; run grille(m,n,tmax,crnd,cener); nu=m*n; run declar(cat,cdd);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
if crnd='O' then seed=1212; else seed=0;
w0=uniform(j(ncol(B),nu,seed));    dimw=ncol(B);
ee=pkor(B); Dc=dcur(D)`;   /*Dc=dcor(D)`; Dc=(D/D[1,+])`; Dc=pkor(D)`;*/
max=max(ee); min=min(ee); w0=w0*(max-min)+min;
if cener='O' then do; run kohoen1(pot,ws,ee,w0,m,n,tmax); potfin=pot[tmax];
reset noname; print " "/; print " Valeur finale de la Variance Intra";
print " ==>> " potfin [format=11.5]; reset name; end;
if cener='N' then ws=kohoe1(ee,w0,m,n,tmax);
comod=codbk(ws,ee,nu); coindiv=codbk(ws,Dc,nu);
code=comod//coindiv; icl=unique(code)`;
eff=rconte(code,nu); efm=rconte(comod,nu); efi=rconte(coindiv,nu);
run convgri(ilig,icol,code,m); run convgri(nlig,ncol,1:nu,m);
        /* construction de la table <<cat>> */
x=code||ilig||icol||(B//D); xe=code||ilig||icol||(ee//Dc`);
mo=char(j(ncol(D),1,0)); ob=char(j(nrow(D),1,0));
do j=1 to ncol(D); mo[j]=concat("mo",char(j,taille(ncol(D))),"="); end;
do j=1 to nrow(D); ob[j]=concat("ob",char(j,taille(nrow(D))),"="); end;
_type_=concat(trim(left((mo//ob))),label);
nacol='_codage_'//'ligne'//'colonne'//modal;
run tablesas(lib,cat,x,nacol,_type_);
       /* construction de la table <<IN>> */
fent=concat(substr(cat,1,5),'_IN'); run tablesas(lib,fent,xe,nacol,_type_);
        /* construction de la table <<CL>> */
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,code,eff,icl,label);
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
                else run tablesas(lib,fcla,rep`,nobs,nvar);
        /* construction de la table <<WS>> */
fws=concat(substr(cat,1,5),'_WS');
cell=char(j(nu,1,0));
do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=nlig||ncol||eff||ws`;
yvc='ligne'//'colonne'//'effectif'//modal;
run tablesas(lib,fws,pdf,yvc,cell);
        /* construction de la table <<NB>> */
fnb=concat(substr(cat,1,5),'_nb');
nbv=efi||efm||eff; vcol='individus'//'modalites'//'total';
run tablesas(lib,fnb,nbv,vcol,cell);
titact=concat('KACM2 : grille ',trim(left(char(m))),'x',trim(left(char(n))),
             ' et ',trim(left(char(tmax))),' iterations');
act=titact; titws='Representants des classes (Poids Finaux)';
info='GRILLE'||'KACM2'; finf=concat('INFO_',upcase(cat));
run tablesas(lib,finf,info,'RESEAU'//'ALGO','obs1');
gkat=concat(lib,'.gacm',substr(cat,1,4));
        /* construction du catalogue iml */
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove nacol yvc x xe pdf k j mo ob seed;
        /* construction du catalogue graphique */
run pahage(comod,modal,4.75,m,n,gkat,titact);
run pahage(code,label,4.75,m,n,gkat,titact);
run lingri(ws,1:ncol(ws),m,n,gkat,titws,modal,1);
titmod=concat('Modalite Moyenne & Representant des ',trim(left(char(nu))),' cellules');
run gcellw(ee,ws,comod,m,n,gkat,titmod);
titind=concat('Individu Moyen & Representant des ',trim(left(char(nu))),' cellules');
run gcellw(Dc`,ws,coindiv,m,n,gkat,titind);
titent=concat('Entree Moyenne & Representant des ',trim(left(char(nu))),' cellules');
run gcellw(ee//Dc`,ws,code,m,n,gkat,titent);
run gcell(ee//Dc`,code,m,n,gkat);
run drikmaha(ee,ws,comod,efm,m,n,gkat,1);
run drik(ws,comod,m,n,gkat,0);
if cdd='O' then run ddw(ws,icl,m,'DX-DY',gkat,1);
if cener='O' then do; call gstart(gkat,1);
  run grol(pot,'Variance intra etendue aux voisins');call gstop; end;
finish kogacm2;
store module=kogacm2;

