start llogri(e,ident,lib,idvar);
/* p= nbre d'observations, q=nbre de variables */
p=nrow(e); q=ncol(e);
if p<q then do; print "  ";
	    print "_______________________________________________________";
	    print "	 >>>>>	 AVERTISSEMENT				  ";
	    print "le nombre de variables depasse le nombre d'observations";
	    print "_______________________________________________________";
	    end;
run grille(m,n,tmax,crnd,cener); run declar(cat,cdd);
run initw0(cint); run pretrait(cpre); nu=m*n; dimw=q;
if crnd='O' then seed=1212; else seed=0; w0=uniform(j(q,nu,seed)); 
if cint='H' & nu<=p then tir=tir(nu,p,seed);	
if cpre='A' then ee=e`;  
if cpre='C' then ee=centr(e)`; 
if cpre='N' then ee=cered(e)`; 
if cpre='K' then ee=diki(e`); 
if cint='E' then do; max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
if cint='H' & nu<=p then w0=ee[,tir];
if cint='H' & nu>p  then 
	do;	max=max(ee); min=min(ee); 
		w0[,1:p]=ee; 
		w0[,p+1:nu]=uniform(j(q,nu-p,seed))*(max-min)+min;
	end;
if cint='F' & cpre='A' then w0=facbrug(e,m,n);
if cint='F' & cpre='C' then w0=faceng(e,m,n);
if cint='F' & cpre='N' then w0=facnorg(e,m,n);
if cint='F' & cpre='K' then w0=facbrug(ee`,m,n);
if cener='O'
   then do; run llogn1(pot,ws,ee,w0,m,n,tmax); potfin=nrj0(ws,ee,m,n,0); end;
if cener='N'
   then do; ws=llog1(ee,w0,m,n,tmax); potfin=nrj0(ws,ee,m,n,0); end;
reset noname; print " "/; print " Valeur finale de la Variance Intra";
print " ==>> " potfin [format=11.5]; reset name;
code=codbk(ws,ee,m*n); label=ident;
eff=rconte(code,m*n);
run convgri(ilig,icol,code,m);
run convgri(nlig,ncol,(1:nu)`,m);
if cpre='K' then do; el=prolig(e); run promy(icl,pfm,code,el,m*n); end;
	    else run promy(icl,pfm,code,e,m*n);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
gkat=concat(lib,'.gacp',substr(cat,1,4));
fws=concat(substr(cat,1,5),'_WS');
fug=concat(substr(cat,1,5),'_UG');
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,code,eff,icl,ident);
centr=pfm`;
mono=cered(centr)`;
cell=char(j(nu,1,0));
do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=nlig||ncol||eff||ws`;
yvc='ligne'//'colonne'//'effectif'//idvar;
if cpre='A' then do;
		     ivc='_codage_'//'ligne'//'colonne'//idvar;
		     x=code||ilig||icol||ee`;  zidvar=' ';
		 end;
	    else do;
		     zidvar=concat('Z',idvar);
		     ivc='_codage_'//'ligne'//'colonne'//idvar//zidvar;
		     x=code||ilig||icol||e||ee`;
		 end;
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
		else run tablesas(lib,fcla,rep`,nobs,nvar);
run tablesas(lib,fws,pdf,yvc,cell);
run tablesas(lib,fug,centr,idvar,nobs);
run tablesas(lib,cat,x,ivc,ident);
titact=concat('KFAST : grille ',trim(left(char(m))),'x',trim(left(char(n)))
	     ,' et ',trim(left(char(tmax))),' iterations');
act='KACP : grille'; titug='Moyennes des classes (valeurs normalisees)';
titws='Representants des classes (Poids Finaux)';
info='GRILLE'||'KFAST'; finf=concat('INFO_',upcase(cat));
run tablesas(lib,finf,info,'RESEAU'//'ALGO','obs1');
call execute("reset storage=",lib,".",cat,";");
remove _all_;
store _all_;
remove ivc yvc x k pdf centr mono nvar seed zidvar;
run pahage(code,ident,4.75,m,n,gkat,titact); run gunit(ee`,code,m,n,gkat,idvar);
titre=concat('Valeur Moyenne & Representant des ',trim(left(char(nu))),' cellules');
run gcellw(ee`,ws,code,m,n,gkat,titre); run drikmaha(ee,ws,code,eff,m,n,gkat,1);
run lingri(ws,1:ncol(ws),m,n,gkat,titws,idvar,0);
if dimw<=50 then run hisgri(ws,1:ncol(ws),m,n,gkat,titws,idvar,0);
if cpre='K' then do; run lingri(pfm,icl,m,n,gkat,titug,idvar,0);
	    if dimw<=50 then run hisgri(pfm,icl,m,n,gkat,titug,idvar,0); end;
	    else do; run lingri(mono,icl,m,n,gkat,titug,idvar,0);
	    if dimw<=50 then run hisgri(mono,icl,m,n,gkat,titug,idvar,0); end;
if cdd='O' then run ddw(ws,icl,m,'DX-DY',gkat,1);
if cener='O' then do; call gstart(gkat,1);
		  run grol(pot,'Variance intra etendue aux voisins');
		  call gstop;
		  end;
finish llogri;
store module=llogri;

