start camfi10col(_codage_,var_qual,n,gkat,titre);
ckam={'vig','yellow','blue','bip','papb','red','cyan','biyg',
        'vioy','black','viro','viv','olive'};
nkolkam=nrow(ckam); nsect=ncol(unique(var_qual));
min=min(unique(var_qual)); max=max(unique(var_qual));
if nsect> nkolkam | (max-min+1)> nkolkam then
do;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE SECTEURS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
if 100/n-int(100/n)>=.5 then ph=int(100/n)+.5; else ph=int(100/n);
xbox={0 0 1 1}; ybox={0 1 1 0};  nu=n;
b={0 0 1 1}; a=j(1,4,0);
call gstart(gkat,1); call gopen("CAMFI10C",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,93,titre,,,1.5,'swissb','red');
 do j= 1 to n;
    a[1]=(j-1)*ph; a[2]=90-ph;
    a[3]=j*ph;     a[4]=90;
    call gwindow(b); call gport(a);
    tj=char(j,taille(nu));
    eff=ncol(loc(_codage_=j));
    if eff>0 then
   do;
    vv=var_qual[loc(_codage_=j)]; val=unique(vv);
    nval=ncol(val); angle=j(1,nval,0); debut=angle; fin=debut;
    coul=j(nval,1,'xxxxxxxx');
           do t=1 to nval;
                angle[t]=ncol(loc(vv=val[t]))*360/eff;
                coul[t]=ckam[val[t]-min+1];           end;
    fin=cusum(angle); fin[nval]=360;
    do t=2 to nval; debut[t]=fin[t-1]; end;
    call gpie(.5,.5,.45,debut,fin,coul,,'s');
    call gpie(.5,.5,.45,debut,fin,'black',-2,'e');
   end;
   call gscript(.05,.85,tj,,,5,'swissb');
   call gpoly(xbox,ybox);
 end;
call gclose; call gshow("CAMFI10C"); call gstop;
finish camfi10col;
store module=camfi10col;

