start contingence(nobs,theo,dev,contrib,marglig,margcol,total,lig,col);
/*
construit le tableau de contingence (nobs)
qui correspond a la clause :   tables lig*col
de la proc freq (col= --> lig | )
entres: lig=question, col=classification
sorties:
nobs (les effectifs observs=nij), theo (eff theoriques),
dev (les deviations), contrib (les contributions au khi2),
marglig (n.j), margcol (ni.), total=n..
*/
vlig=unique(lig); p=ncol(vlig); 
vcol=unique(col); q=ncol(vcol);
nobs=j(p,q,0); theo=nobs; dev=theo; contrib=dev;
do i=1 to p;
  do j=1 to q;
     nobs[i,j]=ncol(xsect(loc(lig=vlig[i]),loc(col=vcol[j])));
  end;
end;
marglig=nobs[+,]; total=marglig[+]; margcol=nobs[,+];
theo=margcol*marglig/total;
dev=nobs-theo;
contrib=dev##2/theo;
finish contingence;
store module=contingence;





