start fcellw10(dat,rep,code,n,gkat,titre);
/* superposition
du representant et des valeurs moyennes des entrees
pour chaque unit de la ficelle <= 10 noeuds */
if 100/n-int(100/n)>=.5 then ph=int(100/n)+.5; else ph=int(100/n);
xbox={0 0 1 1}; ybox={0 1 1 0};
if n<=7 then ch=1.25; else ch=1.5;
b={0 0 1 1}; a=j(1,4,0);
nu=n; p=ncol(dat);
mini=min(min(dat),min(rep)); maxi=max(max(dat),max(rep));
range=maxi-mini;
dd=(dat-mini)/range; dd=.95*dd+.025;
rr=(rep-mini)/range; rr=.95*rr+.025;
t=do(0,1,1/(p-1))`;
call gstart(gkat,1); call gopen("CELLW",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,93,titre,,,1.6,'swissb','red');
  do j= 1 to n;
    a[1]=(j-1)*ph; a[2]=90-ch*ph;
    a[3]=j*ph;     a[4]=90;
    call gwindow(b); call gport(a);
    call gdraw(t,rr[,j],1,'rose');
    nclas=ncol(loc(code=j));
    if nclas=0 then go to saut;
    ddclas=dd[loc(code=j),];
    z=ddclas[:,];
    call gdraw(t,z,1,'steel');
    saut : call gpoly(xbox,ybox,,'green');
  end;
call gclose; call gshow("CELLW"); call gstop;
finish fcellw10;
store module=fcellw10;

