start kofoen1(pot,ws,e,w0,n,tmax);
p=nrow(e); q=ncol(e); nu=n;
if nrow(w0)^=p | ncol(w0)^=nu then return;
eps0=.3; c0=.2;
ws=j(p,nu,0); w=w0; pot=j(tmax,1,0);
do t=1 to tmax;
  r=rayon(nu,n,tmax,t);
  pot[t]=nrj0f(w,e,n,r);
  x=e[,floor(q*uniform(1)+1)];
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];
  epst=eps0/(1+c0*t/nu);
  if r>.5  then v=voisfic(k,n,r);
  if r=.5  then v=voisfic(k,n,1);
  if r=0   then v=k;
  ws=w;
  do j=1 to nrow(v)*ncol(v);
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);
  end;
  w=ws;
end;
finish kofoen1;
store module=kofoen1;

