start potfic(e,ident,lib,idvar);
/* p= nbre d'observations, q=nbre de variables */
p=nrow(e); q=ncol(e);
if p<q then do; print "  " /;
            print "_______________________________________________________";
            print "               SITUATION  FATALE                       ";
            print "le nombre de variables depasse le nombre d'observations";
            print "_______________________________________________________";
            abort;
            end;
run string(n,tmax,crnd);
run dklar(cat);
run pretrait(cpre);
nu=n;
if crnd='O' then seed=1212; else seed=0;
w0=uniform(j(q,nu,seed));
if cpre='A' then
    do; ee=e`; max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
if cpre='C' then
    do; ee=centr(e)`; max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
if cpre='N' then
    do; ee=cered(e)`; max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
if cpre='K' then
    do; ee=diki(e`); max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
run mkofoen(kacp,fast,acp3,acp5,acp7,ws,wf,ws3,ws5,ws7,ee,w0,n,tmax);
finkacp=nrj0f(ws,ee,n,0); finfast=nrj0f(wf,ee,n,0);
finacp3=nrj0f(ws3,ee,n,0); finacp5=nrj0f(ws5,ee,n,0); finacp7=nrj0f(ws7,ee,n,0);
reset noname;
print " "/;
print " Valeur finale de la Variance Intra SOM";
print " ==>> " finkacp [format=11.5];
print " Valeur finale de la Variance Intra SCL";
print " ==>> " finfast [format=11.5];
print " Valeur finale de la Variance Intra KACP3";
print " ==>> " finacp3 [format=11.5];
print " Valeur finale de la Variance Intra KACP5";
print " ==>> " finacp5 [format=11.5];
print " Valeur finale de la Variance Intra KACP7";
print " ==>> " finacp7 [format=11.5];
reset name;
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
gpot=concat(lib,'.gpot',substr(cat,1,4));
fnrj=concat(substr(cat,1,5),'NRJ');
niter=char((1:tmax)`,taille(tmax));
pp=kacp||fast||acp3||acp5||acp7;
idpp='kacp'//'fast'//'acp3'//'acp5'//'acp7';
run tablesas(lib,fnrj,pp,idpp,niter);
titre='KACP=bleu FAST=rouge ACP3=vert ACP5=noir ACP7=gold';
call execute("reset storage=",lib,".",fnrj,";");
remove _all_; store _all_;
call gstart(gpot,1);
run grol(kacp,'Variance Intra KACP');
run grol(fast,'Variance Intra KFAST');
run grol(acp3,'Variance Intra KACP (tout a 3 voisins)');
run grol(acp5,'Variance Intra KACP (tout a 5 voisins)');
run grol(acp7,'Variance Intra KACP (tout a 7 voisins)');
run grol5(kacp,fast,acp3,acp5,acp7,titre);
call gstop;
finish potfic;
store module=potfic;

