start cacolfic(dsn,color,n,gkat,titre);
call execute('use ',dsn,' var {idobs _codage_ cluster var_qual};');
read all; close;
cklus={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
ckam={'vig','yellow','blue','bip','papb','red','cyan','biyg',
        'vioy','black','viro','viv','olive'};
nclus=ncol(unique(cluster)); nkolklu=nrow(cklus);
nkolkam=nrow(ckam); nsect=ncol(unique(var_qual));
min=min(unique(var_qual)); max=max(unique(var_qual));
if nclus> nkolklu | nsect> nkolkam | (max-min+1)> nkolkam then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "                     -et/ou-                              ";
   print " LE NOMBRE DE SECTEURS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
m=int(sqrt(2*n)+1); if n=50 then m=10; r=mod(n,m); q=(n-r)/m;
if r=0  then rg=2*q-1; else rg=2*q+1;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/m-int(100/m)>=.5 then ph=int(100/m)+.5; else ph=int(100/m);
b={0 0 1 1}; a=j(1,4,0); xbox={0 0 1 1}; ybox={0 1 1 0};
call gstart(gkat,1); call gopen("cacolfic",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do j=1 to rg by 2;
 if j^=rg | (j=rg & r=0) then
 do i=1 to m;
     a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
     call gwindow(b); call gport(a); k=i+int(j/2)*m;
    eff=ncol(loc(_codage_=k));
    if eff>0 then
   do;
    kk=unique(cluster[loc(_codage_=k)]);
    call gpoly(xbox,ybox,,'black','solid',cklus[kk]);
    vv=var_qual[loc(_codage_=k)]; val=unique(vv);
    nval=ncol(val); angle=j(1,nval,0); debut=angle; fin=debut;
    coul=j(nval,1,'xxxxxxxx');
           do t=1 to nval;
                angle[t]=ncol(loc(vv=val[t]))*360/eff;
                coul[t]=ckam[val[t]-min+1];
           end;
    fin=cusum(angle); fin[nval]=360;
    do t=2 to nval; debut[t]=fin[t-1]; end;
    call gpie(.5,.5,.45,debut,fin,coul,,'s');
    call gpie(.5,.5,.45,debut,fin,'black',-2,'e');
   end;
             else
do; nc=color[k]; call gpoly(xbox,ybox,,'black','solid',cklus[nc]); end;
 end;
if j=rg & r^=0  then
 do i=1 to r;
     a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
     call gwindow(b); call gport(a); k=i+int(j/2)*m;
    eff=ncol(loc(_codage_=k));
    if eff>0 then
   do;
    kk=unique(cluster[loc(_codage_=k)]);
    call gpoly(xbox,ybox,,'black','solid',cklus[kk]);
    vv=var_qual[loc(_codage_=k)]; val=unique(vv);
    nval=ncol(val); angle=j(1,nval,0); debut=angle; fin=debut;
    coul=j(nval,1,'xxxxxxxx');
           do t=1 to nval;
                angle[t]=ncol(loc(vv=val[t]))*360/eff;
                coul[t]=ckam[val[t]-min+1];
           end;
    fin=cusum(angle); fin[nval]=360;
    do t=2 to nval; debut[t]=fin[t-1]; end;
    call gpie(.5,.5,.45,debut,fin,coul,,'s');
    call gpie(.5,.5,.45,debut,fin,'black',-2,'e');
   end;
             else
do; nc=color[k]; call gpoly(xbox,ybox,,'black','solid',cklus[nc]); end;
 end;
end;
call gclose; call gshow("cacolfic"); call gstop;
finish cacolfic;
store module=cacolfic;

