start codbk(w,e,nu);
/* pour un reseau de nu unites (F ou G)
   e = q vecteurs de R^p
   w = nu vecteurs de R^p
   code = vecteur colonne de q entiers compris entre 1 et nu
   code(j) = numero de l' unite gagnante pour l' entree e^j
*/
p=nrow(e); q=ncol(e);
if nrow(w)^=p | ncol(w)^=nu then return;
code=j(q,1,0);
do j=1 to q;
  x=e[,j];
  code[j]=sqrt((w-repeat(x,1,nu))[##,])[>:<];
end;
return(code);
finish codbk;
store module=codbk;
