start dfil;
run fifi(n,tmax,periode);
nu=n; eps0=.3; c0=.2;
ws=j(2,nu,0); w=10*uniform(j(2,nu,0))-5;
run affil(w,n,0,tmax,0);
do t=1 to tmax;
  x=10*uniform(j(2,1,0))-5;
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];
  epst=eps0/(1+c0*t/nu);
  r=radius(nu,n,tmax,t);
  if r>.5  then v=voisfic(k,n,r);
  if r=.5  then v=voisfic(k,n,1);
  if r=0   then v=k;
  ws=w;
  do j=1 to nrow(v)*ncol(v);
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);
  end;
  if mod(t,periode)=0 then run affil(ws,n,t,tmax,r);
  w=ws;
end;
finish dfil;
store module=dfil;
