start eval(lib);
dsn=datasets(lib);
run queldatqs(datqs,dsn);
dq=trim(left(datqs)); if length(dq)>=10 then dq=substr(dq,1,9);
call execute("use ", lib,".",datqs,";");
nomq=contents();
run choicols(qobs,qvars,nomq);
read all var qvars into vqs;
read all var qobs into qdent;
close;
if type(qdent)='N' then qdent=char(qdent,taille(max(qdent)));
if type(vqs)='N' then run num2nuca(cout,valqs,modal,indice,vqs,qvars);
if type(vqs)='C' then do;
                  run carvnum(valqs,modal,indice,vqs);
                  mattrib indice rowname=modal colname='Valeurs' label='CONVERSION';
                  print indice;
                  end;
run queldatcl(datcl,dsn);
call execute("use ", lib,".",datcl,";");
nomcl=contents();
run quelvacl(cobs,cvar,nomcl);
read all var cvar into clas;
read all var cobs into cdent;
close;
if type(cdent)='N' then cdent=char(cdent,taille(max(cdent)));
if ncol(setdif(qdent,cdent))>0 | ncol(setdif(cdent,qdent))>0
then    do;
print "  " /;
print "_________________________________________________";
print "               PROBLEME DE COHERENCE             ";
print "Pour les valeurs qui identifient les observations";
print "_________________________________________________";
print qdent cdent;
abort;
        end;
cltr=j(nrow(clas),1,0);
do i=1  to nrow(qdent); cltr[i]=clas[loc(cdent=qdent[i])]; end;
run choigraf(g);
if g='N' then run expliq(freq,prct,valt,ordre,tabki2,valqs,cltr,modal,qvars,cvar,lib,dq);
if g='O' then
do;
 catsec=dq;
 if length(catsec)<5 then catsec=concat(catsec,cshape('X',1,1,5-length(catsec)));
 run struc(s);
 if s='G' then
   do;
    run tailgri(m,n);
  catsec=concat(lib,'.',substr(catsec,1,5),trim(left(char(m))),'x',trim(left(char(n))));
 run expligri(freq,prct,valt,ordre,tabki2,valqs,cltr,modal,qvars,cvar,m,n,catsec,lib,dq);
   end;
 if s='F' then
   do;
    run tailfic(nu); catsec=concat(lib,'.',substr(catsec,1,5),trim(left(char(nu))));
    if nu>50 then do;
         print "pas de graphique pour une ficelle de plus de 50 unites";
         run expliq(freq,prct,valt,ordre,tabki2,valqs,cltr,modal,qvars,cvar,lib,dq);
                  end;
    if nu<=10 then
  run explif10(freq,prct,valt,ordre,tabki2,valqs,cltr,modal,qvars,cvar,nu,catsec,lib,dq);
    if nu>10 & nu<=50 then
  run explific(freq,prct,valt,ordre,tabki2,valqs,cltr,modal,qvars,cvar,nu,catsec,lib,dq);
   end;
end;
finish eval;
store module=eval;


