start explific(freq,prct,valt,ordre,tabki2,e,clas,modal,idvar,idcla,n,catg,lib,dsn);
/* entrees :
e(va supp), clas(classif), modal(modalites des va qual supp),
idvar(noms des va supp), idcla (nom de classif), m,n (taille de la grille)
catg (nom du catalogue graphique)
sorties :
freq (tab frequence), prct(tab pourcentages),
valt(tab valtest), ordre(anti-rang les lignes de valt), tabki2(tab khi2)
5 tables sas, graphiques camemberts et histogrammes */
q=ncol(e); ; nm=j(1,q); mm=nrow(modal)*ncol(modal); vcol=unique(clas); nc=ncol(vcol);
dn=trim(left(dsn)); if length(dn)>=10 then dn=substr(dn,1,9);
idcol0=char(vcol,5); idcol1=char(vcol,5)||"Total"; idcol2=char(vcol,5)||"Marge";
idlig=modal//"Total"; idlki2='stat_du_khi2'//'p_value_en_%'//'classement';
freq=j(mm+1,nc+1,0); prct=freq; vt=prct; valt=j(mm,nc,0); ordre=valt;
tabki2=j(3,q,0);
do k=1 to q; nm[k]=ncol(unique(e[,k])); end;
binf=1;
do k=1 to q;
 bsup=binf+nm[k]-1;
 modalig=modal[binf:bsup];
 run conting(tc,totc,totl,modalig,e[,k],clas);
 run ttki2(k2,pval,tc); tabki2[1,k]=k2; tabki2[2,k]=pval;
 freq[binf:bsup,]=tc||totc;
 tit1=concat('Camemberts de la variable : ',idvar[k]);
 run camfic(clas,e[,k],n,catg,tit1);
 run camficol(clas,e[,k],n,catg,tit1);
 tit2=concat('Diagrammes en batons de la variable : ',idvar[k]);
 dat1=repeat(totc,1,ncol(tc));
 run dhisfic(dat1,tc,vcol,n,catg,tit2,modalig,1);
 binf=bsup+1;
end;
freq[mm+1,]=totl;
prct=100*freq/repeat(totl,mm+1,1);
vt=prct/repeat(prct[,nc+1],1,nc+1);
valt=vt[1:mm,1:nc]; control=j(mm,nc,.); zero=valt;
  do i=1 to mm; do j=1 to nc;
   if valt[i,j]=0 then zero[i,j]=.; if valt[i,j]>1 then control[i,j]=1;
  end; end;
valt1=zero#control;
ordre=antorg(valt,vcol,-1);
tabki2[3,]=rank(tabki2[2,]);
mattrib freq rowname=idlig colname=idcol1 label='FREQUENCES' format=5.0;
mattrib prct rowname=idlig  colname=idcol2 label='POURCENTAGES' format=6.2;
mattrib valt rowname=modal colname=idcol0 label='VALEURS TESTS' format=6.2;
mattrib valt1 rowname=modal colname=idcol0 label='VALEURS TESTS > 1' format=6.2;
mattrib ordre rowname=modal colname=idcol0 label='ORDRE DECROISSANT PAR LIGNE' format=4.0;
mattrib tabki2 rowname=idlki2 colname=idvar label='TABLE DES KHI DEUX';
print freq,, prct,, valt,, valt1,, ordre,, tabki2 ;
tabfq=concat(dn,'_frequence','_F_',idcla);    run tablesas(lib,tabfq,freq,idcol1,idlig);
tabpct=concat(dn,'_pourcentage','_F_',idcla); run tablesas(lib,tabpct,prct,idcol2,idlig);
tabvt=concat(dn,'_valtest','_F_',idcla);      run tablesas(lib,tabvt,valt,idcol0,modal);
tabord=concat(dn,'_ordre','_F_',idcla);      run tablesas(lib,tabord,ordre,idcol0,modal);
tabkk=concat(dn,'_tablkhi2','_F_',idcla);    run tablesas(lib,tabkk,tabki2,idvar,idlki2);
finish explific;
store module=explific;

