start llof1(e,w0,n,tmax);
p=nrow(e); q=ncol(e); nu=n;
if nrow(w0)^=p | ncol(w0)^=nu then return;
eps0=.3; c0=.2;
ws=j(p,nu,0); w=w0;
do t=1 to tmax;
  x=e[,floor(q*uniform(1)+1)];
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];
  epst=eps0/(1+c0*t/nu);
  v=k;
  ws=w;
  do j=1 to nrow(v)*ncol(v);
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);
  end;
  w=ws;
end;
return(ws);
finish llof1;
store module=llof1;
